## libselinux 2.1.9

=== include/Makefile ===
# Installation directories.
PREFIX ?= $(DESTDIR)/usr
INCDIR ?= $(PREFIX)/include/selinux

all:

install: all
	test -d $(INCDIR) || install -m 755 -d $(INCDIR)
	install -m 644 $(wildcard selinux/*.h) $(INCDIR)

indent:
	../../scripts/Lindent $(wildcard selinux/*.h)

=== man/Makefile ===
# Installation directories.
MAN8DIR ?= $(DESTDIR)/usr/share/man/man8
MAN5DIR ?= $(DESTDIR)/usr/share/man/man5
MAN3DIR ?= $(DESTDIR)/usr/share/man/man3

all:

install: all
	mkdir -p $(MAN3DIR)
	mkdir -p $(MAN5DIR)
	mkdir -p $(MAN8DIR)
	install -m 644 man3/*.3 $(MAN3DIR)
	install -m 644 man5/*.5 $(MAN5DIR)
	install -m 644 man8/*.8 $(MAN8DIR)

=== src/Makefile ===
# Support building the Python bindings multiple times, against various Python
# runtimes (e.g. Python 2 vs Python 3) by optionally prefixing the build
# targets with "PYPREFIX":
PYTHON ?= python
PYPREFIX ?= $(notdir $(PYTHON))

# Installation directories.
PREFIX ?= $(DESTDIR)/usr
LIBDIR ?= $(PREFIX)/lib
SHLIBDIR ?= $(DESTDIR)/lib
INCLUDEDIR ?= $(PREFIX)/include
PYLIBVER ?= $(shell $(PYTHON) -c 'import sys;print("python%d.%d" % sys.version_info[0:2])')
PYINC ?= $(shell pkg-config --cflags $(PYPREFIX))
PYTHONLIBDIR ?= $(shell pkg-config --libs $(PYPREFIX))
PYLIBDIR ?= $(LIBDIR)/$(PYLIBVER)
RUBYLIBVER ?= $(shell ruby -e 'print RUBY_VERSION.split(".")[0..1].join(".")')
RUBYPLATFORM ?= $(shell ruby -e 'print RUBY_PLATFORM')
RUBYINC ?= $(LIBDIR)/ruby/$(RUBYLIBVER)/$(RUBYPLATFORM)
RUBYINSTALL ?= $(LIBDIR)/ruby/site_ruby/$(RUBYLIBVER)/$(RUBYPLATFORM)
LIBBASE=$(shell basename $(LIBDIR))

VERSION = $(shell cat ../VERSION)
LIBVERSION = 1

LIBA=libselinux.a 
TARGET=libselinux.so
LIBPC=libselinux.pc
SWIGIF= selinuxswig_python.i selinuxswig_python_exception.i
SWIGRUBYIF= selinuxswig_ruby.i
SWIGCOUT= selinuxswig_wrap.c
SWIGRUBYCOUT= selinuxswig_ruby_wrap.c
SWIGLOBJ:= $(patsubst %.c,$(PYPREFIX)%.lo,$(SWIGCOUT))
SWIGRUBYLOBJ:= $(patsubst %.c,%.lo,$(SWIGRUBYCOUT)) 
SWIGSO=$(PYPREFIX)_selinux.so
SWIGFILES=$(SWIGSO) selinux.py
SWIGRUBYSO=_rubyselinux.so
LIBSO=$(TARGET).$(LIBVERSION)
AUDIT2WHYLOBJ=$(PYPREFIX)audit2why.lo
AUDIT2WHYSO=$(PYPREFIX)audit2why.so

ifeq ($(DISABLE_AVC),y)
	UNUSED_SRCS+=avc.c avc_internal.c avc_sidtab.c mapping.c stringrep.c checkAccess.c
endif
ifeq ($(DISABLE_BOOL),y)
	UNUSED_SRCS+=booleans.c
endif
ifeq ($(DISABLE_RPM),y)
	UNUSED_SRCS+=rpm.c
endif

GENERATED=$(SWIGCOUT) $(SWIGRUBYCOUT) selinuxswig_python_exception.i
SRCS= $(filter-out $(UNUSED_SRCS) $(GENERATED) audit2why.c, $(wildcard *.c))

OBJS= $(patsubst %.c,%.o,$(SRCS))
LOBJS= $(patsubst %.c,%.lo,$(SRCS))
CFLAGS ?= -Werror -Wall -W -Wundef -Wshadow -Wmissing-noreturn -Wmissing-format-attribute
override CFLAGS += -I../include -I$(INCLUDEDIR) -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 $(EMFLAGS)
RANLIB=ranlib

ARCH := $(patsubst i%86,i386,$(shell uname -m))
ifneq (,$(filter i386,$(ARCH)))
TLSFLAGS += -mno-tls-direct-seg-refs
endif

SWIG = swig -Wall -python -o $(SWIGCOUT) -outdir ./

SWIGRUBY = swig -Wall -ruby -o $(SWIGRUBYCOUT) -outdir ./

all: $(LIBA) $(LIBSO) $(LIBPC)

pywrap: all $(SWIGSO) $(AUDIT2WHYSO)

rubywrap: all $(SWIGRUBYSO)

$(SWIGLOBJ): $(SWIGCOUT)
	$(CC) $(filter-out -Werror, $(CFLAGS)) $(PYINC) -fPIC -DSHARED -c -o $@ $<

$(SWIGRUBYLOBJ): $(SWIGRUBYCOUT)
	$(CC) $(filter-out -Werror, $(CFLAGS)) -I$(RUBYINC) -fPIC -DSHARED -c -o $@ $<

$(SWIGSO): $(SWIGLOBJ)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $< -L. -lselinux -L$(LIBDIR) $(PYTHONLIBDIR) -Wl,-soname,$@,-z,defs

$(SWIGRUBYSO): $(SWIGRUBYLOBJ)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -L. -lselinux -L$(LIBDIR) -Wl,-soname,$@

$(LIBA): $(OBJS)
	$(AR) rcs $@ $^
	$(RANLIB) $@

$(LIBSO): $(LOBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -ldl -L$(LIBDIR) -Wl,-soname,$(LIBSO),-z,defs,-z,relro
	ln -sf $@ $(TARGET) 

$(LIBPC): $(LIBPC).in ../VERSION
	sed -e 's/@VERSION@/$(VERSION)/; s:@prefix@:$(PREFIX):; s:@libdir@:$(LIBBASE):; s:@includedir@:$(INCLUDEDIR):' < $< > $@

selinuxswig_python_exception.i: ../include/selinux/selinux.h
	bash exception.sh > $@ 

$(AUDIT2WHYLOBJ): audit2why.c
	$(CC) $(filter-out -Werror, $(CFLAGS)) $(PYINC) -fPIC -DSHARED -c -o $@ $<

$(AUDIT2WHYSO): $(AUDIT2WHYLOBJ)
	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -L. -lselinux $(LIBDIR)/libsepol.a -L$(LIBDIR) -Wl,-soname,$@

%.o:  %.c policy.h
	$(CC) $(CFLAGS) $(TLSFLAGS) -c -o $@ $<

%.lo:  %.c policy.h
	$(CC) $(CFLAGS) -fPIC -DSHARED -c -o $@ $<

$(SWIGCOUT): $(SWIGIF)
	$(SWIG) $<

$(SWIGRUBYCOUT): $(SWIGRUBYIF)
	$(SWIGRUBY) $<

swigify: $(SWIGIF)
	$(SWIG) $<

install: all 
	test -d $(LIBDIR) || install -m 755 -d $(LIBDIR)
	install -m 644 $(LIBA) $(LIBDIR)
	test -d $(SHLIBDIR) || install -m 755 -d $(SHLIBDIR)
	install -m 755 $(LIBSO) $(SHLIBDIR)
	test -d $(LIBDIR)/pkgconfig || install -m 755 -d $(LIBDIR)/pkgconfig
	install -m 644 $(LIBPC) $(LIBDIR)/pkgconfig
	cd $(LIBDIR) && ln -sf ../../`basename $(SHLIBDIR)`/$(LIBSO) $(TARGET)

install-pywrap: pywrap
	test -d $(PYLIBDIR)/site-packages/selinux || install -m 755 -d $(PYLIBDIR)/site-packages/selinux
	install -m 755 $(SWIGSO) $(PYLIBDIR)/site-packages/selinux/_selinux.so
	install -m 755 $(AUDIT2WHYSO) $(PYLIBDIR)/site-packages/selinux/audit2why.so
	install -m 644  selinux.py $(PYLIBDIR)/site-packages/selinux/__init__.py

install-rubywrap: rubywrap
	test -d $(RUBYINSTALL) || install -m 755 -d $(RUBYINSTALL) 
	install -m 755 $(SWIGRUBYSO) $(RUBYINSTALL)/selinux.so

relabel:
	/sbin/restorecon $(SHLIBDIR)/$(LIBSO)

clean: 
	-rm -f $(LIBPC) $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(SWIGLOBJ) $(SWIGSO) $(TARGET) $(AUDIT2WHYSO) *.o *.lo *~

distclean: clean
	rm -f $(GENERATED) $(SWIGFILES)

indent:
	../../scripts/Lindent $(filter-out $(GENERATED),$(wildcard *.[ch]))

.PHONY: all clean pywrap rubywrap swigify install install-pywrap install-rubywrap distclean

=== utils/Makefile ===
# Installation directories.
PREFIX ?= $(DESTDIR)/usr
LIBDIR ?= $(PREFIX)/lib
BINDIR ?= $(PREFIX)/sbin
_BINDIR ?= $(DESTDIR)/sbin

CFLAGS ?= -Werror -Wall -W
override CFLAGS += -I../include -D_GNU_SOURCE $(EMFLAGS)
LDLIBS += -L../src -lselinux -L$(LIBDIR)

TARGETS=$(patsubst %.c,%,$(wildcard *.c))


ifeq ($(DISABLE_AVC),y)
	UNUSED_TARGETS+=compute_av compute_create compute_member compute_relabel
endif
ifeq ($(DISABLE_BOOL),y)
	UNUSED_TARGETS+=getsebool togglesebool
endif
TARGETS:= $(filter-out $(UNUSED_TARGETS) matchpathcon, $(TARGETS))

all: $(TARGETS) matchpathcon

install: all
	-mkdir -p $(BINDIR)
	install -m 755 $(TARGETS) $(BINDIR)
	-mkdir -p $(_BINDIR)
	install -m 755 matchpathcon $(_BINDIR)
	(cd $(BINDIR); 	ln -fs ../../sbin/matchpathcon)
clean:
	rm -f $(TARGETS) matchpathcon *.o *~

indent:
	../../scripts/Lindent $(wildcard *.[ch])

relabel:

=== debian/changelog ===
libselinux (2.1.9-2) unstable; urgency=low

  * Moved the python libraries out of the multiarch directory because
    multiarch doesn't seem to work with python.

 -- Russell Coker <russell@coker.com.au>  Tue, 28 Feb 2012 14:19:24 +1100

libselinux (2.1.9-1) unstable; urgency=low

  * New upstream version, lots of man page changes, python related changes,
    and lots of bug fixes.
  * Hacked the build to support multiarch, not sure if it does everything
    that is desired but at least it builds.
  * Added new libselinux1 symbols realpath_not_final, selabel_subs_init,
    selinux_check_access, and selinuxfs_exists.

 -- Russell Coker <russell@coker.com.au>  Mon, 20 Feb 2012 17:31:08 +1100

libselinux (2.1.0-4.1) unstable; urgency=low

  * Non-maintainer upload.
  * debian/control
    - remove comment line since it prevents dch execution
  * debian/patches
    - add fix_FTBFS.patch to adjust path (Closes: #653680)

 -- Hideki Yamane <henrich@debian.org>  Mon, 02 Jan 2012 18:34:40 +0900

=== debian/control ===
Source: libselinux
VCS-Git: git://git.debian.org/~srivasta/debian/libselinux.git
VCS-Browser: http://git.debian.org/git/?p=users/srivasta/debian/libselinux.git
Priority: optional
Section: libs
Maintainer: Russell Coker <russell@coker.com.au>
Uploaders: Manoj Srivastava <srivasta@debian.org>
Standards-Version: 3.9.2
Build-Depends: file, libsepol1-dev (>= 2.1.4), python-all-dev (>= 2.6.6-3~),
               swig, gem2deb (>= 0.2.7~), pkg-config, debhelper (>= 8.1.3~)
X-Python-Version: >= 2.4
XS-Ruby-Versions: ruby1.8 ruby1.9.1

Package: selinux-utils
Architecture: linux-any
Section: admin
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: SELinux utility programs
 This package provides various utility programs for a Security-enhanced
 Linux system. Security-enhanced Linux is a patch of the Linux kernel
 and a number of utilities with enhanced security functionality
 designed to add mandatory access controls to Linux. This package
 provides utility programs to get and set process and file security
 contexts and to obtain security policy decisions.

Package: libselinux1
Architecture: linux-any
Priority: required
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: SELinux runtime shared libraries
 This package provides the shared libraries for Security-enhanced
 Linux that provides interfaces (e.g. library functions for the
 SELinux kernel APIs like getcon(), other support functions like
 getseuserbyname()) to SELinux-aware applications. Security-enhanced
 Linux is a patch of the Linux kernel and a number of utilities with
 enhanced security functionality designed to add mandatory access
 controls to Linux.  The Security-enhanced Linux kernel contains new
 architectural components originally developed to improve the security
 of the Flask operating system. These architectural components provide
 general support for the enforcement of many kinds of mandatory access
 control policies, including those based on the concepts of Type
 Enforcement, Role-based Access Control, and Multi-level Security.
 .
 libselinux1 provides an API for SELinux applications to get and set
 process and file security contexts and to obtain security policy
 decisions.  Required for any applications that use the SELinux
 API. libselinux may use the shared libsepol to manipulate the binary
 policy if necessary (e.g. to downgrade the policy format to an older
 version supported by the kernel) when loading policy.


Package: libselinux1-dev
Architecture: linux-any
Depends: ${misc:Depends}, libselinux1 (= ${binary:Version}),
 libsepol1-dev (>= 1.12)
Section: libdevel
Provides: libselinux-dev
Conflicts: libselinux-dev
Description: SELinux development headers
 This package provides the  static libraries and header files
 needed for developing SELinux applications.  Security-enhanced Linux
 is a patch of the Linux kernel and a number of utilities with
 enhanced security functionality designed to add mandatory access
 controls to Linux.  The Security-enhanced Linux kernel contains new
 architectural components originally developed to improve the security
 of the Flask operating system. These architectural components provide
 general support for the enforcement of many kinds of mandatory access
 control policies, including those based on the concepts of Type
 Enforcement, Role-based Access Control, and Multi-level Security.


Package: ruby-selinux
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}, ruby | ruby-interpreter
Section: ruby
Conflicts: libselinux-ruby1.8 (<= 2.1.0-1)
Replaces: libselinux-ruby1.8 (<= 2.1.0-1)
Provides: libselinx-ruby1.8
Description: Ruby bindings to SELinux shared libraries
 This package provides the Ruby bindings needed for developing Ruby
 SELinux applications.  Security-enhanced Linux is a patch of the
 Linux kernel and a number of utilities with enhanced security
 functionality designed to add mandatory access controls to Linux.
 The Security-enhanced Linux kernel contains new architectural
 components originally developed to improve the security of the Flask
 operating system. These architectural components provide general
 support for the enforcement of many kinds of mandatory access control
 policies, including those based on the concepts of Type Enforcement,
 Role-based Access Control, and Multi-level Security.

Package: libselinux-ruby1.8
Section: oldlibs
Architecture: all
Depends: ${misc:Depends}, ruby-selinux
Description: Transitional package for ruby-selinux
 This is a transitional package to ease upgrades to the ruby-selinux
 package.  It can be safely removed when nothing else depends on it.

Package: python-selinux
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Section: python
Conflicts: python2.4-selinux (<= 1.30-1), libselinux-dev (<= 1.28-1)
Replaces: python2.4-selinux, libselinux-dev
Provides: ${python:Provides}
Description: Python bindings to SELinux shared libraries
 This package provides the Python bindings needed for developing Python
 SELinux applications.
 .
 Security-enhanced Linux is a patch of the Linux kernel and a number
 of utilities with enhanced security functionality designed to add mandatory
 access controls to Linux. The Security-enhanced Linux kernel contains
 new architectural components originally developed to improve the security
 of the Flask operating system. These architectural components provide
 general support for the enforcement of many kinds of mandatory access
 control policies, including those based on the concepts of Type Enforcement,
 Role-based Access Control, and Multi-level Security.

=== debian/rules ===
#! /usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

## Figure out some variables
DEB_HOST_ARCH_OS	:= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
DEB_HOST_GNU_CPU	:= $(shell dpkg-architecture -qDEB_HOST_GNU_CPU)
DEB_HOST_GNU_TYPE	:= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_MULTIARCH	:= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR_LIBSEPOL		:= $(shell pkg-config --variable=libdir libsepol)

# for cross compilation
ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  PREFIX = /usr
else
  PREFIX = /usr/$(DEB_HOST_GNU_TYPE)
endif

## Default target
binary:

## Sanity check
ifneq ($(DEB_HOST_ARCH_OS),linux)
$(error This is a linux only package. Aborting build.)
endif

## Unconditionally run debhelper command targets
.PHONY: FORCE
FORCE:

## By default, pass everything through debhelper automatically
export DH_OPTIONS
%: FORCE
	@dh $@ --with=python2,ruby

## Don't try to rebuild the debian/rules file
debian/rules:
	@touch $@

## Skip python/ruby packages during stage1 build
ifeq ($(DEB_STAGE),stage1)
DH_OPTIONS += -Npython-selinux -Nruby-selinux -Nlibselinux-ruby1.8
endif

## Set up some variables to be passed to the upstream Makefile
extra_make_args  = LIBSEPOLDIR=$(LIBDIR_LIBSEPOL)
extra_make_args += ARCH=$(DEB_HOST_GNU_CPU)
extra_make_args += CC=$(DEB_HOST_GNU_TYPE)-gcc
override_dh_auto_build: FORCE
	+$(MAKE) PREFIX="$(PREFIX)" $(extra_make_args) all

## Work around the very limited SELinux build-system
DESTDIR = $(CURDIR)/debian/tmp
base_extra_install_args  = $(extra_make_args)
base_extra_install_args += DESTDIR=$(DESTDIR)
extra_install_args = $(base_extra_install_args) LIBDIR=$(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)
extra_install_args += SHLIBDIR=$(DESTDIR)/lib/$(DEB_HOST_MULTIARCH)
python_extra_install_args = $(base_extra_install_args) LIBDIR=$(DESTDIR)/usr/lib

override_dh_auto_install: FORCE
	+$(MAKE) PREFIX="$(DESTDIR)$(PREFIX)" $(extra_install_args) install
	@# Fix up the broken library symlink
	rm -f $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libselinux.so
	mkdir $(DESTDIR)/selinux
	ln -s /lib/$(DEB_HOST_MULTIARCH)/libselinux.so.1 $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libselinux.so
	@# Move manpages for user-accessible tools to section 1
	install -d -m 755 $(DESTDIR)/usr/share/man/man1
	mv $(DESTDIR)/usr/share/man/man8/getenforce.8     $(DESTDIR)/usr/share/man/man1/getenforce.1
	mv $(DESTDIR)/usr/share/man/man8/selinuxenabled.8 $(DESTDIR)/usr/share/man/man1/selinuxenabled.1
ifneq ($(DEB_STAGE),stage1)
	+$(MAKE) PREFIX="$(PREFIX)" $(python_extra_install_args) -f debian/python.mk
	+$(MAKE) PREFIX="$(PREFIX)" $(extra_install_args) -f debian/ruby.mk
else
	@echo "Detected stage-1 bootstrap, skipping python/ruby bindings..."
endif

## Generate a hard error for any upstream files we don't install
override_dh_install: FORCE
	dh_install --fail-missing

## libselinux 2.1.12

=== debian/changelog ===
libselinux (2.1.12-1) unstable; urgency=low

  * New upstream release for wheezy+1

 -- Russell Coker <russell@coker.com.au>  Sat, 15 Dec 2012 13:58:54 +1100

libselinux (2.1.9-5) unstable; urgency=low

  * Team upload.
  * Do not Conflicts with ruby transitional package, use versionized Breaks
    instead (Closes: #670058)
  * debian/ruby.mk: Also build for ruby1.9.1 now that's the default version
  * debian/gbp.conf: Change default git-buildpackage build-directory

 -- Laurent Bigonville <bigon@debian.org>  Sun, 10 Jun 2012 08:33:05 +0200

libselinux (2.1.9-4) unstable; urgency=low

  * Team upload.
  * debian/control: Re-add Conflicts/Provides for libselinux1-dev, the Provides
    is still used.

 -- Laurent Bigonville <bigon@debian.org>  Wed, 28 Mar 2012 14:03:32 +0200

libselinux (2.1.9-3) unstable; urgency=low

  * Team upload.
  * debian/control:
    - Bump debhelper build-dependency to 9
    - Move libselinux-ruby1.8 to Priority extra as it's a transitional package
    - Bump Standards-Version to 3.9.3 (no further changes)
    - Drop really old Conflicts/Replaces
    - Bump libselinux1-dev dependency on libsepol1-dev
    - Update Vcs-* fields
    - Bump libsepol1-dev build-dependency so we are sure libdir path is
      correct
    - Put under the Debian SELinux team maintenance
  * debian/libselinux1.lintian-overrides: Drop unused override
  * debian/patches/fix-manpages.patch: Fix section of selinuxexeccon.8
  * debian/patches/allow-libbase-override.patch: Fix .pc file to use multiarch
    path
  * debian/patches/python-link: Do not link against python library
    (Closes: #664291)
  * Add debian/gbp.conf file
  * Drop debian/patches/fix_FTBFS.patch: libsepol.pc is now giving libdir path
  * debian/rules: Append CPPFLAGS hardening flags to CFLAGS

 -- Laurent Bigonville <bigon@debian.org>  Tue, 27 Mar 2012 21:47:29 +0200

## libselinux 2.2.2

=== Makefile ===
SUBDIRS = src include utils man

DISABLE_AVC ?= n
DISABLE_SETRANS ?= n
DISABLE_RPM ?= n
DISABLE_BOOL ?= n
ifeq ($(EMBEDDED),y)
	override DISABLE_AVC=y
	override DISABLE_SETRANS=y
	override DISABLE_RPM=y
	override DISABLE_BOOL=y
endif
ifeq ($(DISABLE_AVC),y)
	EMFLAGS+= -DDISABLE_AVC
endif
ifeq ($(DISABLE_BOOL),y)
	EMFLAGS+= -DDISABLE_BOOL
endif
ifeq ($(DISABLE_SETRANS),y)
	EMFLAGS+= -DDISABLE_SETRANS
endif
export DISABLE_AVC DISABLE_SETRANS DISABLE_RPM DISABLE_BOOL EMFLAGS

all install relabel clean distclean indent:
	@for subdir in $(SUBDIRS); do \
		(cd $$subdir && $(MAKE) $@) || exit 1; \
	done

swigify: all
	$(MAKE) -C src swigify $@

pywrap: 
	$(MAKE) -C src pywrap $@

rubywrap: 
	$(MAKE) -C src rubywrap $@

install-pywrap: 
	$(MAKE) -C src install-pywrap $@

install-rubywrap: 
	$(MAKE) -C src install-rubywrap $@

test:

=== include/Makefile ===
--- 
+++ 
@@ -8,6 +8,11 @@
 	test -d $(INCDIR) || install -m 755 -d $(INCDIR)
 	install -m 644 $(wildcard selinux/*.h) $(INCDIR)
 
+relabel:
+
 indent:
 	../../scripts/Lindent $(wildcard selinux/*.h)
 
+distclean clean:
+	-rm -f selinux/*~
+

=== src/Makefile ===
--- 
+++ 
@@ -3,6 +3,8 @@
 # targets with "PYPREFIX":
 PYTHON ?= python
 PYPREFIX ?= $(notdir $(PYTHON))
+RUBY ?= ruby
+RUBYPREFIX ?= $(notdir $(RUBY))
 
 # Installation directories.
 PREFIX ?= $(DESTDIR)/usr
@@ -11,13 +13,12 @@
 INCLUDEDIR ?= $(PREFIX)/include
 PYLIBVER ?= $(shell $(PYTHON) -c 'import sys;print("python%d.%d" % sys.version_info[0:2])')
 PYINC ?= $(shell pkg-config --cflags $(PYPREFIX))
-PYTHONLIBDIR ?= $(shell pkg-config --libs $(PYPREFIX))
 PYLIBDIR ?= $(LIBDIR)/$(PYLIBVER)
-RUBYLIBVER ?= $(shell ruby -e 'print RUBY_VERSION.split(".")[0..1].join(".")')
-RUBYPLATFORM ?= $(shell ruby -e 'print RUBY_PLATFORM')
-RUBYINC ?= $(LIBDIR)/ruby/$(RUBYLIBVER)/$(RUBYPLATFORM)
+RUBYLIBVER ?= $(shell $(RUBY) -e 'print RUBY_VERSION.split(".")[0..1].join(".")')
+RUBYPLATFORM ?= $(shell $(RUBY) -e 'print RUBY_PLATFORM')
+RUBYINC ?= $(shell pkg-config --cflags ruby)
 RUBYINSTALL ?= $(LIBDIR)/ruby/site_ruby/$(RUBYLIBVER)/$(RUBYPLATFORM)
-LIBBASE=$(shell basename $(LIBDIR))
+LIBBASE ?= $(shell basename $(LIBDIR))
 
 VERSION = $(shell cat ../VERSION)
 LIBVERSION = 1
@@ -33,7 +34,7 @@
 SWIGRUBYLOBJ:= $(patsubst %.c,%.lo,$(SWIGRUBYCOUT)) 
 SWIGSO=$(PYPREFIX)_selinux.so
 SWIGFILES=$(SWIGSO) selinux.py
-SWIGRUBYSO=_rubyselinux.so
+SWIGRUBYSO=$(RUBYPREFIX)_selinux.so
 LIBSO=$(TARGET).$(LIBVERSION)
 AUDIT2WHYLOBJ=$(PYPREFIX)audit2why.lo
 AUDIT2WHYSO=$(PYPREFIX)audit2why.so
@@ -51,11 +52,35 @@
 GENERATED=$(SWIGCOUT) $(SWIGRUBYCOUT) selinuxswig_python_exception.i
 SRCS= $(filter-out $(UNUSED_SRCS) $(GENERATED) audit2why.c, $(wildcard *.c))
 
+MAX_STACK_SIZE=32768
+
 OBJS= $(patsubst %.c,%.o,$(SRCS))
 LOBJS= $(patsubst %.c,%.lo,$(SRCS))
-CFLAGS ?= -Werror -Wall -W -Wundef -Wshadow -Wmissing-noreturn -Wmissing-format-attribute
+CFLAGS ?= -O -Wall -W -Wundef -Wformat-y2k -Wformat-security -Winit-self -Wmissing-include-dirs \
+          -Wunused -Wunknown-pragmas -Wstrict-aliasing -Wshadow -Wpointer-arith \
+          -Wbad-function-cast -Wcast-align -Wwrite-strings -Wlogical-op -Waggregate-return \
+          -Wstrict-prototypes -Wold-style-definition -Wmissing-prototypes \
+          -Wmissing-declarations -Wmissing-noreturn -Wmissing-format-attribute \
+          -Wredundant-decls -Wnested-externs -Winline -Winvalid-pch -Wvolatile-register-var \
+          -Wdisabled-optimization -Wbuiltin-macro-redefined -Wmudflap -Wpacked-bitfield-compat \
+          -Wsync-nand -Wattributes -Wcoverage-mismatch -Wmultichar -Wcpp \
+          -Wdeprecated-declarations -Wdiv-by-zero -Wdouble-promotion -Wendif-labels -Wextra \
+          -Wformat-contains-nul -Wformat-extra-args -Wformat-zero-length -Wformat=2 -Wmultichar \
+          -Wnormalized=nfc -Woverflow -Wpointer-to-int-cast -Wpragmas -Wsuggest-attribute=const \
+          -Wsuggest-attribute=noreturn -Wsuggest-attribute=pure -Wtrampolines \
+          -Wno-missing-field-initializers -Wno-sign-compare -Wjump-misses-init \
+          -Wno-format-nonliteral -Wframe-larger-than=$(MAX_STACK_SIZE) -Wp,-D_FORTIFY_SOURCE=2 \
+          -fstack-protector-all --param=ssp-buffer-size=4 -fexceptions \
+          -fasynchronous-unwind-tables -fdiagnostics-show-option -funit-at-a-time \
+          -fipa-pure-const -Wno-suggest-attribute=pure -Wno-suggest-attribute=const \
+          -Werror -Wno-aggregate-return -Wno-redundant-decls
+
 override CFLAGS += -I../include -I$(INCLUDEDIR) -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64 $(EMFLAGS)
-RANLIB=ranlib
+
+SWIG_CFLAGS += -Wno-error -Wno-unused-variable -Wno-unused-but-set-variable -Wno-unused-parameter \
+		-Wno-shadow -Wno-uninitialized -Wno-missing-prototypes -Wno-missing-declarations
+
+RANLIB ?= ranlib
 
 ARCH := $(patsubst i%86,i386,$(shell uname -m))
 ifneq (,$(filter i386,$(ARCH)))
@@ -73,23 +98,23 @@
 rubywrap: all $(SWIGRUBYSO)
 
 $(SWIGLOBJ): $(SWIGCOUT)
-	$(CC) $(filter-out -Werror, $(CFLAGS)) $(PYINC) -fPIC -DSHARED -c -o $@ $<
+	$(CC) $(CFLAGS) $(SWIG_CFLAGS) $(PYINC) -fPIC -DSHARED -c -o $@ $<
 
 $(SWIGRUBYLOBJ): $(SWIGRUBYCOUT)
-	$(CC) $(filter-out -Werror, $(CFLAGS)) -I$(RUBYINC) -fPIC -DSHARED -c -o $@ $<
+	$(CC) $(CFLAGS) $(SWIG_CFLAGS) $(RUBYINC) -fPIC -DSHARED -c -o $@ $<
 
 $(SWIGSO): $(SWIGLOBJ)
-	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $< -L. -lselinux -L$(LIBDIR) $(PYTHONLIBDIR) -Wl,-soname,$@,-z,defs
+	$(CC) $(CFLAGS) -shared -o $@ $< -L. -lselinux $(LDFLAGS) -L$(LIBDIR)
 
 $(SWIGRUBYSO): $(SWIGRUBYLOBJ)
-	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -L. -lselinux -L$(LIBDIR) -Wl,-soname,$@
+	$(CC) $(CFLAGS) -shared -o $@ $^ -L. -lselinux $(LDFLAGS) -L$(LIBDIR)
 
 $(LIBA): $(OBJS)
 	$(AR) rcs $@ $^
 	$(RANLIB) $@
 
 $(LIBSO): $(LOBJS)
-	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -ldl -L$(LIBDIR) -Wl,-soname,$(LIBSO),-z,defs,-z,relro
+	$(CC) $(CFLAGS) -shared -o $@ $^ -lpcre -ldl $(LDFLAGS) -L$(LIBDIR) -Wl,-soname,$(LIBSO),-z,defs,-z,relro
 	ln -sf $@ $(TARGET) 
 
 $(LIBPC): $(LIBPC).in ../VERSION
@@ -102,7 +127,7 @@
 	$(CC) $(filter-out -Werror, $(CFLAGS)) $(PYINC) -fPIC -DSHARED -c -o $@ $<
 
 $(AUDIT2WHYSO): $(AUDIT2WHYLOBJ)
-	$(CC) $(CFLAGS) $(LDFLAGS) -shared -o $@ $^ -L. -lselinux $(LIBDIR)/libsepol.a -L$(LIBDIR) -Wl,-soname,$@
+	$(CC) $(CFLAGS) -shared -o $@ $^ -L. $(LDFLAGS) -lselinux $(LIBDIR)/libsepol.a -L$(LIBDIR)
 
 %.o:  %.c policy.h
 	$(CC) $(CFLAGS) $(TLSFLAGS) -c -o $@ $<
@@ -142,7 +167,7 @@
 	/sbin/restorecon $(SHLIBDIR)/$(LIBSO)
 
 clean: 
-	-rm -f $(LIBPC) $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(SWIGLOBJ) $(SWIGSO) $(TARGET) $(AUDIT2WHYSO) *.o *.lo *~
+	-rm -f $(LIBPC) $(OBJS) $(LOBJS) $(LIBA) $(LIBSO) $(SWIGLOBJ) $(SWIGRUBYLOBJ) $(SWIGSO) $(TARGET) $(AUDIT2WHYSO) *.o *.lo *~
 
 distclean: clean
 	rm -f $(GENERATED) $(SWIGFILES)

=== utils/Makefile ===
# Installation directories.
PREFIX ?= $(DESTDIR)/usr
LIBDIR ?= $(PREFIX)/lib
USRBINDIR ?= $(PREFIX)/sbin
SBINDIR ?= $(DESTDIR)/sbin

MAX_STACK_SIZE=8192
CFLAGS ?= -O -Wall -W -Wundef -Wformat-y2k -Wformat-security -Winit-self -Wmissing-include-dirs \
          -Wunused -Wunknown-pragmas -Wstrict-aliasing -Wshadow -Wpointer-arith \
          -Wbad-function-cast -Wcast-align -Wwrite-strings -Wlogical-op -Waggregate-return \
          -Wstrict-prototypes -Wold-style-definition -Wmissing-prototypes \
          -Wmissing-declarations -Wmissing-noreturn -Wmissing-format-attribute \
          -Wredundant-decls -Wnested-externs -Winline -Winvalid-pch -Wvolatile-register-var \
          -Wdisabled-optimization -Wbuiltin-macro-redefined -Wmudflap -Wpacked-bitfield-compat \
          -Wsync-nand -Wattributes -Wcoverage-mismatch -Wmultichar -Wcpp \
          -Wdeprecated-declarations -Wdiv-by-zero -Wdouble-promotion -Wendif-labels -Wextra \
          -Wformat-contains-nul -Wformat-extra-args -Wformat-zero-length -Wformat=2 -Wmultichar \
          -Wnormalized=nfc -Woverflow -Wpointer-to-int-cast -Wpragmas -Wsuggest-attribute=const \
          -Wsuggest-attribute=noreturn -Wsuggest-attribute=pure -Wtrampolines \
          -Wno-missing-field-initializers -Wno-sign-compare -Wjump-misses-init \
          -Wno-format-nonliteral -Wframe-larger-than=$(MAX_STACK_SIZE) -Wp,-D_FORTIFY_SOURCE=2 \
          -fstack-protector-all --param=ssp-buffer-size=4 -fexceptions \
          -fasynchronous-unwind-tables -fdiagnostics-show-option -funit-at-a-time \
          -fipa-pure-const -Wno-suggest-attribute=pure -Wno-suggest-attribute=const \
          -Werror -Wno-aggregate-return -Wno-redundant-decls
override CFLAGS += -I../include -D_GNU_SOURCE $(EMFLAGS)
LDLIBS += -L../src -lselinux -L$(LIBDIR)

TARGETS=$(patsubst %.c,%,$(wildcard *.c))

sefcontext_compile: LDLIBS += -lpcre

ifeq ($(DISABLE_AVC),y)
	UNUSED_TARGETS+=compute_av compute_create compute_member compute_relabel
endif
ifeq ($(DISABLE_BOOL),y)
	UNUSED_TARGETS+=getsebool togglesebool
endif
TARGETS:= $(filter-out $(UNUSED_TARGETS), $(TARGETS))

all: $(TARGETS)

install: all
	-mkdir -p $(USRBINDIR)
	install -m 755 $(TARGETS) $(USRBINDIR)
	-mkdir -p $(SBINDIR)
clean:
	rm -f $(TARGETS) *.o *~

distclean: clean

indent:
	../../scripts/Lindent $(wildcard *.[ch])

relabel:

=== debian/changelog ===
libselinux (2.2.2-1ubuntu0.1) trusty; urgency=high

  * Correct libselinu1 postinst for re-executing upstart. (LP: #1313712)

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 28 Apr 2014 14:51:48 +0100

libselinux (2.2.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
  * debian/control: Mark -dev package as Multi-arch: same. (Closes: #732098)
  * debian/control: Bump Standards-Version to 3.9.5 (no further changes)
  * debian/rules: Fix cross build, no need for a different prefix.

 -- Laurent Bigonville <bigon@debian.org>  Sat, 11 Jan 2014 18:44:53 +0100

libselinux (2.2.1-1) unstable; urgency=low

  * Team upload.
  * New upstream release
  * Drop debian/patches/link_pthread.patch: Upstream disagreed with this
    solution, this will unfortunately require to rebuild some of the
    rdependencies

 -- Laurent Bigonville <bigon@debian.org>  Sun, 10 Nov 2013 20:33:34 +0100

libselinux (2.2-2) unstable; urgency=low

  * Team upload.
  * debian/patches/link_pthread.patch: Explicitly link against -lpthread as
    libselinux is using it internally, without this ld.so is asserting in a
    weird way for some executables (Closes: #728529)

 -- Laurent Bigonville <bigon@debian.org>  Sat, 02 Nov 2013 22:42:37 +0100

libselinux (2.2-1) unstable; urgency=low

  * Team upload.
  * New upstream release
    - Fix avc_has_perm() returns -1 even when SELinux is permissive.
      (Closes: #727766)
    - debian/control: Bump {build-}dependencies to match new release
    - debian/patches/fix-makefile-bugs.patch: Refreshed
    - Drop debian/patches/fix-manpages.patch: Not needed anymore
    - debian/patches/fix-cross-compile.patch: Refreshed
    - Drop debian/patches/allow-libbase-override.patch: Merged upstream
    - Drop debian/patches/fix_pcre_link.patch: Fixed upstream
    - Drop debian/patches/add_missing_private_pc.patch: Fixed upstream
    - Adjust debian/libselinux1.symbols: Add new symbols
  * debian/rules: getenforce and selinuxenabled executable are installed in
    /usr/sbin, keep their manpages in section 8

 -- Laurent Bigonville <bigon@debian.org>  Fri, 01 Nov 2013 17:02:00 +0100

libselinux (2.1.13-3) unstable; urgency=low

  * Team upload.
  * debian/ruby.mk: Stop building binding for ruby 1.8 and start building it
    for ruby 2.0 (Closes: #720247)
  * debian/control: Bump Standards-Version to 3.9.4 (no further changes)
  * debian/control: Use canonical URL for VCS-Git field
  * debian/control, debian/rules: Drop libselinux-ruby1.8 transitional package

 -- Laurent Bigonville <bigon@debian.org>  Wed, 02 Oct 2013 18:32:57 +0200

libselinux (2.1.13-2) unstable; urgency=low

  * Team upload.
  * debian/patches/add_missing_private_pc.patch: Add missing dependencies to
    the .pc file. This fix FTBFS of pkg that link statically against us
    (Closes: #708435)
  * debian/control: Add Dependency against libpcre3-dev on libselinux1-dev
    package

 -- Laurent Bigonville <bigon@debian.org>  Mon, 20 May 2013 17:36:35 +0200

libselinux (2.1.13-1) unstable; urgency=low

  * Team upload.
  * New upstream release
    - debian/control: Bump libsepol1-dev (build-)dependency to match the release
    - Refresh the patches
    - debian/libselinux1.symbols: Add new symbol
  * debian/control: Add Homepage field

 -- Laurent Bigonville <bigon@debian.org>  Thu, 09 May 2013 18:55:50 +0200

libselinux (2.1.12-1) experimental; urgency=low

  * Team upload.
  * New upstream release
    - Drop debian/patches/python-include and fix debian/python.mk instead
    - Drop debian/patches/python-link, applied upstream
    - Drop debian/patches/hide-library-destructors.patch, applied upstream
    - Refresh debian/patches/allow-libbase-override.patch
    - Drop debian/patches/add-includededir this patch was actually reverting
      debian/patches/fix-cross-compile.patch
    - Refresh debian/patches/fix-cross-compile.patch
    - Bump libsepol1 {build-}dependency to match the new released version
    - Add libpcre3-dev build-dependency
    - Add debian/patches/fix_pcre_link.patch: Fix LDFLAGS and libpcre linking
    - Refresh debian/patches/fix-makefile-bugs.patch
    - Fix debian/ruby.mk: Add missing -I to RUBYINC variabale
    - Adjust debian/libselinux1.symbols symbols file, dropped unused symbol:
      flush_class_cache
    - debian/selinux-utils.install: matchpathcon exec has moved to /usr/sbin
  * Update debian/watch file
  * debian/gbp.conf: change the debian-branch to "debian" instead of "upstream"
  * Drop /selinux directory, selinuxfs should now be mounted in
    /sys/fs/selinux (Closes: #658070)

 -- Laurent Bigonville <bigon@debian.org>  Tue, 25 Sep 2012 23:32:29 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,24 @@
 Source: libselinux
-VCS-Git: git://git.debian.org/~srivasta/debian/libselinux.git
-VCS-Browser: http://git.debian.org/git/?p=users/srivasta/debian/libselinux.git
+VCS-Git: git://anonscm.debian.org/selinux/libselinux.git
+VCS-Browser: http://anonscm.debian.org/gitweb/?p=selinux/libselinux.git;a=summary
 Priority: optional
 Section: libs
-Maintainer: Russell Coker <russell@coker.com.au>
-Uploaders: Manoj Srivastava <srivasta@debian.org>
-Standards-Version: 3.9.2
-Build-Depends: file, libsepol1-dev (>= 2.1.4), python-all-dev (>= 2.6.6-3~),
-               swig, gem2deb (>= 0.2.7~), pkg-config, debhelper (>= 8.1.3~)
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
+Uploaders: Manoj Srivastava <srivasta@debian.org>,
+           Russell Coker <russell@coker.com.au>
+Standards-Version: 3.9.5
+Build-Depends: debhelper (>= 9),
+               file,
+               gem2deb (>= 0.2.7~),
+               libsepol1-dev (>= 2.2),
+               libpcre3-dev,
+               pkg-config,
+               python-all-dev (>= 2.6.6-3~),
+               swig
 X-Python-Version: >= 2.4
-XS-Ruby-Versions: ruby1.8 ruby1.9.1
+XS-Ruby-Versions: all
+Homepage: http://userspace.selinuxproject.org/
 
 Package: selinux-utils
 Architecture: linux-any
@@ -50,12 +59,14 @@
  policy if necessary (e.g. to downgrade the policy format to an older
  version supported by the kernel) when loading policy.
 
-
 Package: libselinux1-dev
 Architecture: linux-any
-Depends: ${misc:Depends}, libselinux1 (= ${binary:Version}),
- libsepol1-dev (>= 1.12)
+Depends: libselinux1 (= ${binary:Version}),
+         libsepol1-dev (>= 2.2),
+         libpcre3-dev,
+         ${misc:Depends}
 Section: libdevel
+Multi-Arch: same
 Provides: libselinux-dev
 Conflicts: libselinux-dev
 Description: SELinux development headers
@@ -70,14 +81,10 @@
  control policies, including those based on the concepts of Type
  Enforcement, Role-based Access Control, and Multi-level Security.
 
-
 Package: ruby-selinux
 Architecture: linux-any
-Depends: ${misc:Depends}, ${shlibs:Depends}, ruby | ruby-interpreter
+Depends: ruby | ruby-interpreter, ${misc:Depends}, ${shlibs:Depends}
 Section: ruby
-Conflicts: libselinux-ruby1.8 (<= 2.1.0-1)
-Replaces: libselinux-ruby1.8 (<= 2.1.0-1)
-Provides: libselinx-ruby1.8
 Description: Ruby bindings to SELinux shared libraries
  This package provides the Ruby bindings needed for developing Ruby
  SELinux applications.  Security-enhanced Linux is a patch of the
@@ -90,20 +97,10 @@
  policies, including those based on the concepts of Type Enforcement,
  Role-based Access Control, and Multi-level Security.
 
-Package: libselinux-ruby1.8
-Section: oldlibs
-Architecture: all
-Depends: ${misc:Depends}, ruby-selinux
-Description: Transitional package for ruby-selinux
- This is a transitional package to ease upgrades to the ruby-selinux
- package.  It can be safely removed when nothing else depends on it.
-
 Package: python-selinux
 Architecture: linux-any
-Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
+Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
 Section: python
-Conflicts: python2.4-selinux (<= 1.30-1), libselinux-dev (<= 1.28-1)
-Replaces: python2.4-selinux, libselinux-dev
 Provides: ${python:Provides}
 Description: Python bindings to SELinux shared libraries
  This package provides the Python bindings needed for developing Python

=== debian/rules ===
--- 
+++ 
@@ -10,12 +10,7 @@
 DEB_HOST_MULTIARCH	:= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 LIBDIR_LIBSEPOL		:= $(shell pkg-config --variable=libdir libsepol)
 
-# for cross compilation
-ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
-  PREFIX = /usr
-else
-  PREFIX = /usr/$(DEB_HOST_GNU_TYPE)
-endif
+PREFIX = /usr
 
 ## Default target
 binary:
@@ -24,6 +19,10 @@
 ifneq ($(DEB_HOST_ARCH_OS),linux)
 $(error This is a linux only package. Aborting build.)
 endif
+
+## The build system doesn't use CPPFLAGS, pass them to CFLAGS to enable the
+## missing (hardening) flags.
+export DEB_CFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)
 
 ## Unconditionally run debhelper command targets
 .PHONY: FORCE
@@ -40,7 +39,7 @@
 
 ## Skip python/ruby packages during stage1 build
 ifeq ($(DEB_STAGE),stage1)
-DH_OPTIONS += -Npython-selinux -Nruby-selinux -Nlibselinux-ruby1.8
+DH_OPTIONS += -Npython-selinux -Nruby-selinux
 endif
 
 ## Set up some variables to be passed to the upstream Makefile
@@ -48,7 +47,7 @@
 extra_make_args += ARCH=$(DEB_HOST_GNU_CPU)
 extra_make_args += CC=$(DEB_HOST_GNU_TYPE)-gcc
 override_dh_auto_build: FORCE
-	+$(MAKE) PREFIX="$(PREFIX)" $(extra_make_args) all
+	+$(MAKE) PREFIX="$(PREFIX)" LIBBASE="lib/${DEB_HOST_MULTIARCH}" $(extra_make_args) all
 
 ## Work around the very limited SELinux build-system
 DESTDIR = $(CURDIR)/debian/tmp
@@ -62,12 +61,7 @@
 	+$(MAKE) PREFIX="$(DESTDIR)$(PREFIX)" $(extra_install_args) install
 	@# Fix up the broken library symlink
 	rm -f $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libselinux.so
-	mkdir $(DESTDIR)/selinux
 	ln -s /lib/$(DEB_HOST_MULTIARCH)/libselinux.so.1 $(DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/libselinux.so
-	@# Move manpages for user-accessible tools to section 1
-	install -d -m 755 $(DESTDIR)/usr/share/man/man1
-	mv $(DESTDIR)/usr/share/man/man8/getenforce.8     $(DESTDIR)/usr/share/man/man1/getenforce.1
-	mv $(DESTDIR)/usr/share/man/man8/selinuxenabled.8 $(DESTDIR)/usr/share/man/man1/selinuxenabled.1
 ifneq ($(DEB_STAGE),stage1)
 	+$(MAKE) PREFIX="$(PREFIX)" $(python_extra_install_args) -f debian/python.mk
 	+$(MAKE) PREFIX="$(PREFIX)" $(extra_install_args) -f debian/ruby.mk

## libselinux 2.3

=== debian/changelog ===
libselinux (2.3-2) unstable; urgency=medium

  * Team upload.
  * Add debian/patches/Add-pcre-version-string.patch: Add pcre version string
    to the compiled file_contexts format. This is necesarry to detect the
    cases where the internal libpcre representation has changed, if it's the
    case libselinux will rely on the non-compiled file (Closes: #756826)
  * Add debian/patches/Log-an-error-on-unknown-classes.patch: Log an error on
    unknown classes and permissions.
  * d/p/libselinux-man-Add-missing-manpage-links-to-security.patch: Add the
    missing manpage links for selinux_mkload_policy(3) and
    selinux_init_load_policy(3) (Closes: #753803)
  * Drop debian/libselinux1.postinst: Reloading systemd during an upgrade in
    an uncontroled way might endup with unwanted side effects (Closes: #753726)

 -- Laurent Bigonville <bigon@debian.org>  Sun, 31 Aug 2014 20:57:58 +0200

libselinux (2.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - debian/control: Bump {build-}dependencies to match new release
    - debian/libselinux1.symbols: Add new setexecfilecon() function
  * debian/ruby.mk: Rework the makefile, it should handle changes in the
    supported ruby versions by binNMU now (Closes: #747683)
  * Add Built-Using field for python-selinux as audit2why.so is statically
    linking against libsepol

 -- Laurent Bigonville <bigon@debian.org>  Wed, 14 May 2014 20:13:57 +0200

libselinux (2.2.2-2) unstable; urgency=medium

  * Team upload.
  [ Laurent Bigonville ]
  * debian/rules: Do not require ruby or python dh helpers when bootstrapping
    thanks to Daniel Schepler <dschepler@gmail.com> (Closes: #738148)

  [ Hideki Yamane ]
  * debian/{ruby.mk,ruby-selinux.install}
    - drop related to ruby1.9.1 and add ruby2.1.0 instead (Closes: #746024)

 -- Laurent Bigonville <bigon@debian.org>  Fri, 02 May 2014 01:47:58 +0200

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,14 @@
 VCS-Browser: http://anonscm.debian.org/gitweb/?p=selinux/libselinux.git;a=summary
 Priority: optional
 Section: libs
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
+Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Manoj Srivastava <srivasta@debian.org>,
            Russell Coker <russell@coker.com.au>
 Standards-Version: 3.9.5
 Build-Depends: debhelper (>= 9),
                file,
-               gem2deb (>= 0.2.7~),
-               libsepol1-dev (>= 2.2),
+               gem2deb (>= 0.5.0~),
+               libsepol1-dev (>= 2.3),
                libpcre3-dev,
                pkg-config,
                python-all-dev (>= 2.6.6-3~),
@@ -62,7 +61,7 @@
 Package: libselinux1-dev
 Architecture: linux-any
 Depends: libselinux1 (= ${binary:Version}),
-         libsepol1-dev (>= 2.2),
+         libsepol1-dev (>= 2.3),
          libpcre3-dev,
          ${misc:Depends}
 Section: libdevel
@@ -100,6 +99,7 @@
 Package: python-selinux
 Architecture: linux-any
 Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
+Built-Using: ${Built-Using}
 Section: python
 Provides: ${python:Provides}
 Description: Python bindings to SELinux shared libraries

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,8 @@
 LIBDIR_LIBSEPOL		:= $(shell pkg-config --variable=libdir libsepol)
 
 PREFIX = /usr
+
+BUILT_USING=$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W "libsepol1-dev")
 
 ## Default target
 binary:
@@ -31,7 +33,11 @@
 ## By default, pass everything through debhelper automatically
 export DH_OPTIONS
 %: FORCE
+ifeq ($(DEB_STAGE),stage1)
+	@dh $@
+else
 	@dh $@ --with=python2,ruby
+endif
 
 ## Don't try to rebuild the debian/rules file
 debian/rules:
@@ -72,3 +78,6 @@
 ## Generate a hard error for any upstream files we don't install
 override_dh_install: FORCE
 	dh_install --fail-missing
+
+override_dh_gencontrol:
+	dh_gencontrol -- -VBuilt-Using="$(BUILT_USING)"

## libselinux 2.4

=== src/Makefile ===
--- 
+++ 
@@ -44,9 +44,6 @@
 endif
 ifeq ($(DISABLE_BOOL),y)
 	UNUSED_SRCS+=booleans.c
-endif
-ifeq ($(DISABLE_RPM),y)
-	UNUSED_SRCS+=rpm.c
 endif
 
 GENERATED=$(SWIGCOUT) $(SWIGRUBYCOUT) selinuxswig_python_exception.i
@@ -151,7 +148,7 @@
 	install -m 755 $(LIBSO) $(SHLIBDIR)
 	test -d $(LIBDIR)/pkgconfig || install -m 755 -d $(LIBDIR)/pkgconfig
 	install -m 644 $(LIBPC) $(LIBDIR)/pkgconfig
-	cd $(LIBDIR) && ln -sf ../../`basename $(SHLIBDIR)`/$(LIBSO) $(TARGET)
+	ln -sf --relative $(SHLIBDIR)/$(LIBSO) $(LIBDIR)/$(TARGET)
 
 install-pywrap: pywrap
 	test -d $(PYLIBDIR)/site-packages/selinux || install -m 755 -d $(PYLIBDIR)/site-packages/selinux

=== debian/changelog ===
libselinux (2.4-3build2) xenial; urgency=medium

  * No-change rebuild for ruby2.3 support.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 16 Mar 2016 10:48:05 +0000

libselinux (2.4-3build1) xenial; urgency=medium

  * No-change rebuild to drop python3.4 support.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Jan 2016 13:33:24 +0000

libselinux (2.4-3) unstable; urgency=medium

  * Team upload.
  * Upload to unstable
  * debian/python.mk: Add $(PYTHON3_VERSIONS) to the PHONY target

 -- Laurent Bigonville <bigon@debian.org>  Wed, 18 Nov 2015 18:11:37 +0100

libselinux (2.4-2) experimental; urgency=medium

  * Team upload.
  * debian/control: Also bump the dependency against libsepol1-dev to 2.4
  * Start building python 3 packages

 -- Laurent Bigonville <bigon@debian.org>  Fri, 10 Jul 2015 22:02:08 +0200

libselinux (2.4-1) experimental; urgency=medium

  * Team upload.
  * New upstream release
    - Bump libsepol1-dev build-dependency to >= 2.4 to match the release
    - Drop d/p/Add-pcre-version-string.patch,
      d/p/Log-an-error-on-unknown-classes.patch and
      d/p/libselinux-man-Add-missing-manpage-links-to-security.patch: Applied
      upstream.
    - debian/patches/fix-makefile-bugs.patch: Refreshed
  * debian/watch: Update watch file URL
  * debian/control: Bump Standards-Version to 3.9.6 (no further changes)

 -- Laurent Bigonville <bigon@debian.org>  Wed, 03 Jun 2015 08:18:37 +0200

=== debian/control ===
--- 
+++ 
@@ -6,16 +6,19 @@
 Maintainer: Debian SELinux maintainers <selinux-devel@lists.alioth.debian.org>
 Uploaders: Manoj Srivastava <srivasta@debian.org>,
            Russell Coker <russell@coker.com.au>
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Build-Depends: debhelper (>= 9),
+               dh-python,
                file,
                gem2deb (>= 0.5.0~),
-               libsepol1-dev (>= 2.3),
+               libsepol1-dev (>= 2.4),
                libpcre3-dev,
                pkg-config,
                python-all-dev (>= 2.6.6-3~),
+               python3-all-dev,
                swig
 X-Python-Version: >= 2.4
+X-Python3-Version: >= 3.2
 XS-Ruby-Versions: all
 Homepage: http://userspace.selinuxproject.org/
 
@@ -61,7 +64,7 @@
 Package: libselinux1-dev
 Architecture: linux-any
 Depends: libselinux1 (= ${binary:Version}),
-         libsepol1-dev (>= 2.3),
+         libsepol1-dev (>= 2.4),
          libpcre3-dev,
          ${misc:Depends}
 Section: libdevel
@@ -114,3 +117,22 @@
  general support for the enforcement of many kinds of mandatory access
  control policies, including those based on the concepts of Type Enforcement,
  Role-based Access Control, and Multi-level Security.
+
+Package: python3-selinux
+Architecture: linux-any
+Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
+Built-Using: ${Built-Using}
+Section: python
+Provides: ${python3:Provides}
+Description: Python3 bindings to SELinux shared libraries
+ This package provides the Python3 bindings needed for developing Python
+ SELinux applications.
+ .
+ Security-enhanced Linux is a patch of the Linux kernel and a number
+ of utilities with enhanced security functionality designed to add mandatory
+ access controls to Linux. The Security-enhanced Linux kernel contains
+ new architectural components originally developed to improve the security
+ of the Flask operating system. These architectural components provide
+ general support for the enforcement of many kinds of mandatory access
+ control policies, including those based on the concepts of Type Enforcement,
+ Role-based Access Control, and Multi-level Security.

=== debian/rules ===
--- 
+++ 
@@ -36,7 +36,7 @@
 ifeq ($(DEB_STAGE),stage1)
 	@dh $@
 else
-	@dh $@ --with=python2,ruby
+	@dh $@ --with=python2,python3,ruby
 endif
 
 ## Don't try to rebuild the debian/rules file
@@ -45,7 +45,7 @@
 
 ## Skip python/ruby packages during stage1 build
 ifeq ($(DEB_STAGE),stage1)
-DH_OPTIONS += -Npython-selinux -Nruby-selinux
+DH_OPTIONS += -Npython-selinux -Nruby-selinux -Npython3-selinux
 endif
 
 ## Set up some variables to be passed to the upstream Makefile
